Attribute VB_Name = "Date_Module"
Option Explicit
Option Base 0
Public GDayTab(2, 13) As Long
Public JDayTab(2, 13) As Long
Public Const GYearOff = 226894
Public Const Solar = 365.25
Public Const JWkDayOff = 3
Public Const GWkDayOff = 0

Function Jleap(Year As Long) As Long

    Dim tmp As Long
    tmp = Year Mod 33
    If (tmp = 1 Or tmp = 5 Or tmp = 9 Or tmp = 13 Or tmp = 17 Or tmp = 22 Or tmp = 26 Or tmp = 30) Then
        Jleap = 1
    Else
        Jleap = 0
    End If

End Function

Function JDayOfYear(Year As Long, Month As Long, day As Long) As Long
    Dim i As Long, leap As Long
    leap = Jleap(Year)
    For i = 1 To Month - 1
        day = day + JDayTab(leap, i)
    Next i
    JDayOfYear = day
End Function



Function JLeapYears(jyear As Long) As Long

Dim leap As Long, CurrentCycle As Long, Div33 As Long, i As Long
Div33 = Int(jyear / 33)
CurrentCycle = jyear - (Div33 * 33)
leap = Div33 * 8
If CurrentCycle > 0 Then
    i = 1
    Do While i <= CurrentCycle And i <= 18
        leap = leap + 1
        i = i + 4
    Loop
End If
If CurrentCycle > 21 Then
    i = 22
    Do While i <= CurrentCycle And i <= 30
        leap = leap + 1
        i = i + 4
    Loop
End If
JLeapYears = leap

End Function


Function JalaliDays(jyear As Long, jmonth As Long, jday As Long) As Long

Dim TotalDays As Long
Dim leap, tmp As Long
leap = JLeapYears(jyear - 1)
tmp = JDayOfYear(jyear, jmonth, jday)
TotalDays = (jyear - 1) * 365 + leap + tmp
JalaliDays = TotalDays
End Function


Public Function GDayOfYear(Year As Long, Month As Long, day As Long) As Long

Dim i As Long, leap As Long
leap = Gleap(Year)
For i = 1 To Month - 1
    day = day + GDayTab(leap, i)
Next i
GDayOfYear = day

End Function

Public Function FDate(Jdate As String) As String

Dim Year As String, Month As String, day As String
If Len(Jdate) < 8 Then
    day = Right(Jdate, 2)
    Month = Mid(Jdate, 3, 2)
    Year = Left(Jdate, 2)
Else
    day = Right(Jdate, 2)
    Month = Mid(Jdate, 5, 2)
    Year = Left(Jdate, 4)
End If
FDate = Year + "/" + Month + "/" + day

End Function


Public Function Gleap(Year As Long) As Long
If ((Year Mod 4 = 0 And Year Mod 100 <> 0) Or Year Mod 400 = 0) Then
    Gleap = 1
Else
    Gleap = 0
End If
End Function

Public Sub GMonthDay(GYear As Long, GDayOfYear, Month, day)
Dim i As Long, leap As Long
leap = Gleap(GYear)
i = 1
Do While GDayOfYear > GDayTab(leap, i)
    GDayOfYear = GDayOfYear - GDayTab(leap, i)
    i = i + 1
Loop
Month = i
day = GDayOfYear
End Sub

Public Function GregDays(GYear As Long, GMonth As Long, GDay As Long) As Long
Dim Div4 As Long, Div100 As Long, Div400 As Long
Dim TotalDays  As Long, tmp As Long
Div4 = Int((GYear - 1) / 4)
Div100 = Int((GYear - 1) / 100)
Div400 = Int((GYear - 1) / 400)
tmp = GDayOfYear(GYear, GMonth, GDay)
TotalDays = (GYear - 1) * 365 + tmp + Div4 - Div100 + Div400
GregDays = TotalDays
End Function

Public Function GregorianDate(Jdate As String, Optional mode As String) As String
Dim jyear As Long, jmonth As Long, jday As Long
Dim GYear As Long, GMonth As Long, GDay As Long
Dim TotalDays As Long
jyear = Year_(Jdate)
If Len(Jdate) = 6 Then jyear = jyear + 1300
jmonth = Month_(Jdate)
jday = Day_(Jdate)
TotalDays = JalaliDays(jyear, jmonth, jday)
GregorianYMD TotalDays, GYear, GMonth, GDay
GregorianDate = YMD2Str(GYear, GMonth, GDay, mode)
End Function

Public Sub GregorianYMD(TotalDays As Long, GYear As Long, GMonth As Long, GDay As Long)
Dim Div4 As Long, Div100 As Long, Div400 As Long
Dim GDays As Long
TotalDays = TotalDays + GYearOff
GYear = Int(TotalDays / (Solar - 0.25 / 33))
Div4 = Int(GYear / 4)
Div100 = Int(GYear / 100)
Div400 = Int(GYear / 400)
GDays = TotalDays - (365 * GYear) - (Div4 - Div100 + Div400)
GYear = GYear + 1
If GDays = 0 Then
    GYear = GYear - 1
    If Gleap(GYear) Then
        GDays = 366
    Else
        GDays = 365
    End If
ElseIf (GDays = 366 And Gleap(GYear) = 0) Then
    GDays = 1
    GYear = GYear + 1
End If
GMonthDay GYear, GDays, GMonth, GDay
End Sub


Public Function YMD2Str(Year As Long, Month As Long, day As Long, Optional mode As String) As String
Dim Y As String, M As String, d As String
Y = LTrim(Str(Year))
M = LTrim(Str(Month))
If Len(M) <> 2 Then
    M = "0" + M
End If
d = LTrim(Str(day))
If Len(d) <> 2 Then
    d = "0" + d
End If
If mode = "" Then
    mode = "SHORT"
Else
    mode = UCase(mode)
End If
Select Case mode
Case "LONG"
    YMD2Str = Y + M + d
Case Else
    YMD2Str = Right(Y, 2) + M + d
End Select
End Function

Public Sub JalaliYMD(TotalDays As Long, jyear As Long, jmonth As Long, jday As Long)
Dim JDays As Long
Dim leap As Long
TotalDays = TotalDays - GYearOff
jyear = Int(TotalDays / (Solar - 0.25 / 33))
leap = JLeapYears(jyear)
JDays = TotalDays - (365 * jyear + leap)
jyear = jyear + 1
If JDays = 0 Then
    jyear = jyear - 1
    If Jleap(jyear) Then
        JDays = 366
    Else
        JDays = 365
    End If
ElseIf (JDays = 366 And Jleap(jyear) = 0) Then
    JDays = 1
    jyear = jyear + 1
End If
JMonthDay jyear, JDays, jmonth, jday
End Sub

Public Function Day_(Date_ As String) As Long
Day_ = CLng(Right(Date_, 2))
End Function


Public Function Month_(Date_ As String) As Long
Select Case Len(Date_)
Case 8
    Month_ = CLng(Mid(Date_, 5, 2))
Case Else
    Month_ = CLng(Mid(Date_, 3, 2))
End Select
End Function

Public Sub JMonthDay(jyear As Long, JDayOfYear As Long, Month As Long, day As Long)
Dim i As Long, leap As Long
leap = Jleap(jyear)
i = 1
Do While JDayOfYear > JDayTab(leap, i)
    JDayOfYear = JDayOfYear - JDayTab(leap, i)
    i = i + 1
Loop
Month = i
day = JDayOfYear
End Sub

Public Sub DateModuleSetup()
Dim i As Long

JDayTab(0, 0) = 0: JDayTab(1, 0) = 0
For i = 1 To 6
    JDayTab(0, i) = 31
    JDayTab(1, i) = 31
Next i
For i = 7 To 11
    JDayTab(0, i) = 30
    JDayTab(1, i) = 30
Next i
JDayTab(0, 12) = 29: JDayTab(1, 12) = 30

GDayTab(0, 0) = 0: GDayTab(1, 0) = 0
GDayTab(0, 1) = 31: GDayTab(1, 1) = 31
GDayTab(0, 2) = 28: GDayTab(1, 2) = 29
GDayTab(0, 3) = 31: GDayTab(1, 3) = 31
GDayTab(0, 4) = 30: GDayTab(1, 4) = 30
GDayTab(0, 5) = 31: GDayTab(1, 5) = 31
GDayTab(0, 6) = 30: GDayTab(1, 6) = 30
GDayTab(0, 7) = 31: GDayTab(1, 7) = 31
GDayTab(0, 8) = 31: GDayTab(1, 8) = 31
GDayTab(0, 9) = 30: GDayTab(1, 9) = 30
GDayTab(0, 10) = 31: GDayTab(1, 10) = 31
GDayTab(0, 11) = 30: GDayTab(1, 11) = 30
GDayTab(0, 12) = 31: GDayTab(1, 12) = 31
End Sub

Public Function Year_(Date_ As String) As Long
Select Case Len(Date_)
Case 8
    Year_ = CLng(Left(Date_, 4))
Case Else
    Year_ = CLng(Left(Date_, 2))
End Select
End Function

Public Function JalaliDate(GDate As String, Optional mode As String) As String

Dim GYear As Long, GMonth As Long, GDay As Long
Dim jyear As Long, jmonth As Long, jday As Long
Dim TotalDays As Long
GYear = Year_(GDate)
If Len(GDate) = 6 Then GYear = GYear + 1900
GMonth = Month_(GDate)
GDay = Day_(GDate)
TotalDays = GregDays(GYear, GMonth, GDay)
JalaliYMD TotalDays, jyear, jmonth, jday
JalaliDate = YMD2Str(jyear, jmonth, jday, mode)

End Function



